// Copyright 2017 Orus.io. All rights reserved.

package control

import (
	"context"

	"xbus.io/go-xbus/v3/api/control"
)

type logsServer struct {
	*Service
}

func (s logsServer) Purge(
	ctx context.Context, req control.LogsPurgeRequest,
	send func(control.LogsPurgeReply),
) (
	err error,
) {
	send(control.LogsPurgeReply{
		Count: s.o.LogStorage.PurgeBefore(req.Before),
	})
	return nil
}

func (s logsServer) GetStorageStat(ctx context.Context) (control.StorageStat, error) {
	entry, err := s.o.LogStorage.Stat()
	if err != nil {
		return control.StorageStat{}, err
	}
	return control.StorageStat{
		Entries: []control.StorageStat_Entry{*entry},
	}, nil
}
